unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SAPIInterface;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
//------------------------------------------------------------------------------
// Edit control
var
  Handle: dword;
  SaveCaretPos: TPoint;
  OldPosition: integer;
  SaveSelStart: integer;

procedure OutSpeech(Text: string);
begin
  Stop;
  Speak(Text);
end;

function SelStart: integer;
begin
  Result := LongRec(SendMessage(Handle, EM_GETSEL, 0, 0)).Hi;
  SaveSelStart := Result;
end;

function SelEnd: integer;
begin
  Result := LongRec(SendMessage(Handle, EM_GETSEL, 0, 0)).Lo;
end;


function TextLength: integer;
begin
  Result := GetWindowTextLength(Handle);
end;

function GetCaretPos: TPoint;
begin
  Result.X := SelStart;
  Result.Y := SendMessage(Handle, EM_LINEFROMCHAR, Result.X, 0);
  Result.X := Result.X - SendMessage(Handle, EM_LINEINDEX, -1, 0);
  SaveCaretPos := Result;
end;

function GetLine(Line: integer): string;
var
  Text: array[0..4095] of Char;
begin
  Word((@Text)^) := SizeOf(Text);
  SetString(Result, Text, SendMessage(Handle, EM_GETLINE, Line, Longint(@Text)));
end;

function GetLineCount: integer;
begin
  Result := SendMessage(Handle, EM_LINEFROMCHAR, TextLength, 0);
end;

procedure LeftRightCaret;
var
  OutString: string;
  CaretPos: TPoint;
  i: integer;
begin
  CaretPos := GetCaretPos;
  OutString := GetLine(CaretPos.Y);
  if OutString <> '' then OutString := OutString[CaretPos.X + 1];
  if OutString = #0 then OutString := '';
  if OutString = '' then OutString := 'empty';
  if CaretPos.X = Length(GetLine(CaretPos.Y)) then OutString := OutString + ' end of line';
  if SelStart = 0 then OutString := OutString + ' begin of text';
  if SelStart = TextLength then OutString := OutString + ' end of text';
  OutSpeech(OutString);
end;

procedure BackSpace;
var
  OutString: string;
  CaretPos: TPoint;
  i: integer;
begin
  CaretPos := GetCaretPos;
  CaretPos.X := CaretPos.X - 1;
  OutString := GetLine(CaretPos.Y);
  if OutString <> '' then OutString := OutString[CaretPos.X + 1];
  if OutString = #0 then OutString := '';
  if OutString = '' then OutString := 'empty';
  if CaretPos.X = Length(GetLine(CaretPos.Y)) then OutString := OutString + ' end of line';
  if SelStart = 0 then OutString := OutString + ' begin of text';
  if SelStart = TextLength then OutString := OutString + ' end of text';
  OutSpeech(OutString);
end;


procedure UpDownCaret;
var
  OutString: string;
  CaretPos: TPoint;
begin
  CaretPos := GetCaretPos;
  OutString := GetLine(CaretPos.Y);
  if OutString = '' then OutString := 'empty';
  if CaretPos.Y = 0 then OutString := OutString + ' begin of text';
  if CaretPos.Y = GetLineCount then OutString := OutString + ' end of text';
  OutSpeech(OutString);
end;

procedure WorldJump;
var
  OldSelPos, SelPos: integer;
  OutString: string;
  CaretPos: TPoint;
  OldCaretPos: TPoint;
begin
  OldSelPos := SaveSelStart;
  SelPos := SelStart;
  OldCaretPos := SaveCaretPos;
  if SaveCaretPos.X = Length(GetLine(SaveCaretPos.Y)) then
    if OldSelPos > SelPos then inc(OldSelPos)
    else inc(SelPos);

  CaretPos := GetCaretPos;
  if CaretPos.Y <> OldCaretPos.Y then
  begin
    OutSpeech('nl');
    Exit;
  end;
  if CaretPos.X = Length(GetLine(CaretPos.Y)) then
    if OldSelPos > SelPos then inc(OldSelPos)
    else inc(SelPos);

  if OldSelPos > SelPos then OutString := Copy(Form1.Memo1.Text, SelPos, OldSelPos - SelPos)
  else OutString := Copy(Form1.Memo1.Text, OldSelPos, SelPos - OldSelPos);

  if OutString = '' then OutString := 'empty';
  if SelStart = 0 then OutString := OutString + ' begin of text';
  if SelStart = TextLength then OutString := OutString + ' end of text';
  OutSpeech(OutString);
end;

procedure ChangeSelection;
var
  OutString: string;
begin
  OutString := Copy(Form1.Memo1.Text, SelEnd, SelStart - SelEnd + 1);
  OutSpeech(OutString);
end;

procedure InitControl(hwnd: dword);
begin
  Handle := hwnd;
  SaveCaretPos := GetCaretPos;
end;
//------------------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
begin
  SAPIInterface.CreateSpeech;
  SAPIInterface.PSelectEngineNumber(2);
  InitControl(Memo1.Handle);
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
 OutString: string;
begin
  if ssCtrl in Shift then
    case Key of
      VK_LEFT, VK_RIGHT: WorldJump;
      VK_END, VK_HOME: UpDownCaret;
    end
  else
    case Key of
      VK_UP, VK_DOWN, VK_NEXT, VK_PRIOR: UpDownCaret;
      VK_LEFT, VK_RIGHT, VK_HOME, VK_END: LeftRightCaret;
  else
    begin

      if SelStart <> SelEnd then
      begin
        ChangeSelection;
        Exit;
      end;

    end;
   end; 
    OldPosition := SelStart;

end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #08 then Exit;
  OutSpeech(Key);
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_BACK then BackSpace;
  if Key = VK_DELETE then LeftRightCaret;
end;

end.

